# bunkchat 🏰

**bunkchat** is ultra-simple, local-only group chat for tilde servers written in posix sh

## install
```
git clone https://git.bunk.computer/bunk/bunkchat.git && \
cd ./bunkchat && \
sudo ./install.sh
```

## usage
bunkchat is comprised of three separate programs
1. **proclaim** - post in chat
1. **heed** - read current chat
1. **scry** - read old chat

run `proclaim` and `heed` in adjacent terminals for best ux

## security
hopefully!

- the chat log is append only, but anyone can append anything to it
- `proclaim` only accepts user input with `read -r`, which does not expand variables, and appends to the chat log with `echo "$userinput" >> $chatlog`
- `heed` only does `tail -f` on the chat log
- `scry` only opens the chat log with `less`
- no one has execute permissions on the chat log

if you find a security issue, please [contact us](mailto:contact@bunk.computer)

## notes
bunkchat is one large group chat that every user on the server is part of

if your file system does not support setting append only permissions with `chattr +a`, install.sh will fail

bunkchat should work on all standard linuces. not tested on bsd

